Index: pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/RootViewController.h
===================================================================
--- pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/RootViewController.h	(revision 3551)
+++ pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/RootViewController.h	(revision 3552)
@@ -1,10 +1,20 @@
-//
-//  RootViewController.h
-//  ipjsystest
-//
-//  Created by Liong Sauw Ming on 3/20/10.
-//  Copyright Teluu Inc. (http://www.teluu.com) 2010. All rights reserved.
-//
-
+/* $Id$ */
+/* 
+ * Copyright (C) 2010-2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
 #import "TestViewController.h"
 
Index: pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/RootViewController.m
===================================================================
--- pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/RootViewController.m	(revision 3551)
+++ pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/RootViewController.m	(revision 3552)
@@ -1,10 +1,20 @@
-//
-//  RootViewController.m
-//  ipjsystest
-//
-//  Created by Liong Sauw Ming on 3/20/10.
-//  Copyright Teluu Inc. (http://www.teluu.com) 2010. All rights reserved.
-//
-
+/* $Id$ */
+/* 
+ * Copyright (C) 2010-2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
 #import "RootViewController.h"
 #import "gui.h"
Index: pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/TestViewController.h
===================================================================
--- pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/TestViewController.h	(revision 3551)
+++ pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/TestViewController.h	(revision 3552)
@@ -1,10 +1,20 @@
-//
-//  TestViewController.h
-//  ipjsystest
-//
-//  Created by Liong Sauw Ming on 3/20/10.
-//  Copyright 2010 Teluu Inc. (http://www.teluu.com). All rights reserved.
-//
-
+/* $Id$ */
+/* 
+ * Copyright (C) 2010-2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
 #import <UIKit/UIKit.h>
 
Index: pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/TestViewController.m
===================================================================
--- pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/TestViewController.m	(revision 3551)
+++ pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/TestViewController.m	(revision 3552)
@@ -1,10 +1,20 @@
-//
-//  TestViewController.m
-//  ipjsystest
-//
-//  Created by Liong Sauw Ming on 3/20/10.
-//  Copyright 2010 Teluu Inc. (http://www.teluu.com). All rights reserved.
-//
-
+/* $Id$ */
+/* 
+ * Copyright (C) 2010-2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
 #import "TestViewController.h"
 
Index: pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/ipjsystestAppDelegate.h
===================================================================
--- pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/ipjsystestAppDelegate.h	(revision 3551)
+++ pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/ipjsystestAppDelegate.h	(revision 3552)
@@ -1,10 +1,20 @@
-//
-//  ipjsystestAppDelegate.h
-//  ipjsystest
-//
-//  Created by Liong Sauw Ming on 3/20/10.
-//  Copyright Teluu Inc. (http://www.teluu.com) 2010. All rights reserved.
-//
-
+/* $Id$ */
+/* 
+ * Copyright (C) 2010-2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
 @interface ipjsystestAppDelegate : NSObject <UIApplicationDelegate> {
     
Index: pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/ipjsystestAppDelegate.m
===================================================================
--- pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/ipjsystestAppDelegate.m	(revision 3551)
+++ pjproject/trunk/pjsip-apps/src/ipjsystest/Classes/ipjsystestAppDelegate.m	(revision 3552)
@@ -1,10 +1,20 @@
-//
-//  ipjsystestAppDelegate.m
-//  ipjsystest
-//
-//  Created by Liong Sauw Ming on 3/20/10.
-//  Copyright Teluu Inc. (http://www.teluu.com) 2010. All rights reserved.
-//
-
+/* $Id$ */
+/* 
+ * Copyright (C) 2010-2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
 #import "ipjsystestAppDelegate.h"
 #import "RootViewController.h"
Index: pjproject/trunk/pjsip-apps/src/ipjsystest/main.m
===================================================================
--- pjproject/trunk/pjsip-apps/src/ipjsystest/main.m	(revision 3551)
+++ pjproject/trunk/pjsip-apps/src/ipjsystest/main.m	(revision 3552)
@@ -1,10 +1,20 @@
-//
-//  main.m
-//  ipjsystest
-//
-//  Created by Liong Sauw Ming on 3/20/10.
-//  Copyright Teluu Inc. (http://www.teluu.com) 2010. All rights reserved.
-//
-
+/* $Id$ */
+/* 
+ * Copyright (C) 2010-2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
 #import <UIKit/UIKit.h>
 